"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var oly_1 = require("oly");
var keys_1 = require("../constants/keys");
var IndexDecorator = /** @class */ (function () {
    function IndexDecorator(options) {
        if (options === void 0) { options = {}; }
        this.options = options;
    }
    IndexDecorator.prototype.asProperty = function (target, propertyKey) {
        oly_1.Meta
            .of({ target: target, propertyKey: propertyKey, key: keys_1.olyMongoKeys.indexes })
            .set(this.options);
    };
    return IndexDecorator;
}());
exports.IndexDecorator = IndexDecorator;
/**
 * Index a field.
 */
exports.index = oly_1.Meta.decorator(IndexDecorator);
//# sourceMappingURL=index.js.map