"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var mongodb_1 = require("mongodb");
var oly_1 = require("oly");
var keys_1 = require("../constants/keys");
var DatabaseProvider = /** @class */ (function () {
    function DatabaseProvider() {
        /**
         * Mongodb URI.
         */
        this.url = "mongodb://localhost/test";
    }
    DatabaseProvider.prototype.onStart = function (deps) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var url, _a, _i, deps_1, dep;
            return tslib_1.__generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        url = this.url.indexOf("mongodb://") === 0
                            ? this.url
                            : "mongodb://" + this.url;
                        _a = this;
                        return [4 /*yield*/, mongodb_1.MongoClient.connect(url)];
                    case 1:
                        _a.client = _b.sent();
                        this.db = this.client.db();
                        this.logger.info("connected to " + this.url);
                        _i = 0, deps_1 = deps;
                        _b.label = 2;
                    case 2:
                        if (!(_i < deps_1.length)) return [3 /*break*/, 5];
                        dep = deps_1[_i];
                        if (!(dep.instance
                            && dep.instance.collectionName
                            && dep.instance.type)) return [3 /*break*/, 4];
                        return [4 /*yield*/, this.index(dep.instance.collectionName, dep.instance.type)];
                    case 3:
                        _b.sent();
                        _b.label = 4;
                    case 4:
                        _i++;
                        return [3 /*break*/, 2];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    DatabaseProvider.prototype.onStop = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.client.close()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    DatabaseProvider.prototype.index = function (collectionName, type) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var meta, keys, _i, keys_2, key, _a;
            return tslib_1.__generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        meta = oly_1.Meta.of({ target: type, key: keys_1.olyMongoKeys.indexes }).get();
                        if (!meta) {
                            return [2 /*return*/];
                        }
                        keys = Object.keys(meta.properties);
                        _i = 0, keys_2 = keys;
                        _b.label = 1;
                    case 1:
                        if (!(_i < keys_2.length)) return [3 /*break*/, 6];
                        key = keys_2[_i];
                        if (!meta.properties[key].text) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.db.collection(collectionName).createIndex((_a = {}, _a[key] = "text", _a), {
                                unique: meta.properties[key].unique,
                            })];
                    case 2:
                        _b.sent();
                        return [3 /*break*/, 5];
                    case 3: return [4 /*yield*/, this.db.collection(collectionName).createIndex(key, {
                            unique: meta.properties[key].unique,
                        })];
                    case 4:
                        _b.sent();
                        _b.label = 5;
                    case 5:
                        _i++;
                        return [3 /*break*/, 1];
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    tslib_1.__decorate([
        oly_1.env("DATABASE_URL"),
        tslib_1.__metadata("design:type", String)
    ], DatabaseProvider.prototype, "url", void 0);
    tslib_1.__decorate([
        oly_1.state,
        tslib_1.__metadata("design:type", mongodb_1.MongoClient)
    ], DatabaseProvider.prototype, "client", void 0);
    tslib_1.__decorate([
        oly_1.state,
        tslib_1.__metadata("design:type", mongodb_1.Db)
    ], DatabaseProvider.prototype, "db", void 0);
    tslib_1.__decorate([
        oly_1.inject,
        tslib_1.__metadata("design:type", oly_1.Kernel)
    ], DatabaseProvider.prototype, "kernel", void 0);
    tslib_1.__decorate([
        oly_1.inject,
        tslib_1.__metadata("design:type", oly_1.Logger)
    ], DatabaseProvider.prototype, "logger", void 0);
    return DatabaseProvider;
}());
exports.DatabaseProvider = DatabaseProvider;
//# sourceMappingURL=DatabaseProvider.js.map